// Java class androidSync.AndroidSync is a proxy for talking to a Go program.
//   gobind -lang=java androidSync
//
// File is generated by gobind. Do not edit.
package androidSync;

import go.Seq;

public abstract class AndroidSync {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private AndroidSync() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	
	
	/**
	 * 	关闭临时创建的节点
	 */
	public static native boolean closeSearchNode();
	/**
	 * 	创建查询集群的临时节点，需要传入集群密码，6字节，数字或字母
		每个一秒调用一次GetSearchNodes，拿到搜索到的节点信息数据
		最后调用CloseSearchNode，关闭临时创建的搜索节点
		pwd = password must six bytes
	 */
	public static native boolean createSearchNodeByPwd(String pwd);
	/**
	 * 	加入集群后，可以通过该接口获取集群的节点信息，不过最好直接查同步库的集群节点表
	json vector
	[
	{Node1},
	{Node2},
	...
	{Noden}
	]
	type NodeInfo struct {
		ClusterID   string `json:&#34;clusterID&#34;`
		NodeID      string `json:&#34;nodeID&#34;`
		NodeAddress string `json:&#34;nodeAddress&#34;`
		IsAlive     int    `json:&#34;isAlive&#34;` //StatusNone:0, StatusAlive:1, StatusLeaving:2, StatusLeft:3, StatusFailed:4
	}
	 */
	public static native byte[] getNodes();
	/**
	 * 	获取搜索到的节点信息
	json vector
	[
	{Node1},
	{Node2},
	...
	{Noden}
	]
	type NodeInfo struct {
		ClusterID   string `json:&#34;clusterID&#34;`
		NodeID      string `json:&#34;nodeID&#34;`
		NodeAddress string `json:&#34;nodeAddress&#34;`
		IsAlive     int    `json:&#34;isAlive&#34;`  //StatusNone:0, StatusAlive:1, StatusLeaving:2, StatusLeft:3, StatusFailed:4
	}
	 */
	public static native byte[] getSearchNodes();
	/**
	 * 	每次开机后都会调用该接口，该接口会去查询数据库，确实之前是否已经加入过集群，若是已经加入集群，则开机自动加入
	 */
	public static native boolean initAgent(String devID);
	/**
	 * 	初始化时，若没能加入集群，可以通过该接口加入集群。
		strAddrs = &#34;ip1:port1;ip2:port2;ip3:port3&#34;
	 */
	public static native boolean joinByNodeAddrs(String strAddrs);
	/**
	 * 	加入集群，包含初始化节点SyncInit，并根据传入的集群其他节点列表自动加入集群
		strAddrs = &#34;ip1:port1;ip2:port2;ip3:port3&#34;
	 */
	public static native boolean joinCluster(String clusterID, String password, String strAddrs, String devID, String devIP, String devName);
	/**
	 * 	退出集群
	 */
	public static native boolean leave();
	/**
	 * 	之前没有集群。调用此接口进行集群初始化，传入集群其他节点的ip，便于初始化后直接加入集群
		strAddrs = &#34;ip1:port1;ip2:port2;ip3:port3&#34;
	 */
	public static native boolean syncInit(String clusterID, String password, String nodeID, String strAddrs);
	/**
	 * 	操作数据库后，需要调用该接口将对应的sql语句同步到集群
		strSql = &#34;sql1;sql2;sql3;...;sqln&#34;
	 */
	public static native void syncSql(String strSql);
	/**
	 * 	更新集群的名字
	 */
	public static native boolean updateClusterName(String clusterName, String clusterID);
}
